unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    StringGrid1: TStringGrid;
    Label1: TLabel;
    UpDown1: TUpDown;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    StringGrid2: TStringGrid;
    Label3: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label6: TLabel;
    Memo1: TMemo;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Button4: TButton;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    procedure Button3Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    FUNCTION  GetMax(const n,m:byte; Sender: TObject):byte;
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure N1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
p:array[0..9]of char=('x','y','z','m','n','o','p','q','r','s');
var
  Form1: TForm1;
  i,j,count,d,n,m:integer;
  myRect: TGridRect;
  max_n, z:byte;           // z -    
  k:array[0..9]of string[99];  //  '12' '-1/2'
  fa:real;
  fb:string;
implementation

uses Unit3;

{$R *.dfm}

PROCEDURE SetFormat(var a:real;var b:string;const z:byte);
var
st:string;
BEGIN
str(a:8:z,st);
while st[1]=' ' do delete(st,1,1);
while st[length(st)]='0' do delete(st,length(st),1);
if (st[length(st)]='.')or(st[length(st)]=',') then delete(st,length(st),1);
if pos('.',st)<>0 then st[pos('.',st)]:=',';
a:=strtofloat(st);
b:=st;
END;

///////       /////////////////
PROCEDURE DecoderStr(const st0:string; var a,b:int64);
var
n:byte;
BEGIN
n:=pos('/',st0);
if n=0 then
 begin
  //  st0 = '-12'
  a:=strtoint64(st0);
  b:=1;
 end else
 begin
  //  st0 = '-12/5'
  a:=strtoint64(copy(st0,1,n-1));
  b:=strtoint64(copy(st0,n+1,99));
 end;
END;

///////   /////////////////////////////////////////
//      tmp_a - , tmp_b - 
PROCEDURE Sokr(var tmp_a,tmp_b:int64);
var
flag:boolean;
BEGIN
if tmp_a mod tmp_b=0 then
 begin                   //  
  tmp_a:=tmp_a div tmp_b;
  tmp_b:=1;
 end else
 begin                   //  
  repeat
   flag:=false;          //  
   if (tmp_a mod 2=0)and(tmp_b mod 2=0) then
    begin
     tmp_a:=tmp_a div 2;
     tmp_b:=tmp_b div 2;
     flag:=true;
    end;
   if (tmp_a mod 3=0)and(tmp_b mod 3=0) then
    begin
     tmp_a:=tmp_a div 3;
     tmp_b:=tmp_b div 3;
     flag:=true;
    end;
   if (tmp_a mod 5=0)and(tmp_b mod 5=0) then
    begin
     tmp_a:=tmp_a div 5;
     tmp_b:=tmp_b div 5;
     flag:=true;
    end;
  until flag=false;
 end;
END;

///////     /////////////////////////////
PROCEDURE Proizv(const st0,st1:string; var a,b:int64);
var
a0,b0,a1,b1,tmp_a,tmp_b:int64;
BEGIN
DecoderStr(st0,a0,b0);
DecoderStr(st1,a1,b1);
tmp_a:=a0*a1;
tmp_b:=b0*b1;
Sokr(tmp_a,tmp_b);
a:=tmp_a;
b:=tmp_b;
END;

///////     /////////////////////////////
PROCEDURE Delenie(const st0,st1:string; var a,b:int64);
var
a0,b0,a1,b1,tmp_a,tmp_b:int64;
BEGIN
DecoderStr(st0,a0,b0);
DecoderStr(st1,a1,b1);
tmp_a:=a0*b1;
tmp_b:=b0*a1;
Sokr(tmp_a,tmp_b);
a:=tmp_a;
b:=tmp_b;
END;

///////     /////////////////////////////
PROCEDURE Summa(const st0,st1:string; var a,b:int64);
var
a0,b0,a1,b1,tmp_a,tmp_b:int64;
BEGIN
DecoderStr(st0,a0,b0);
DecoderStr(st1,a1,b1);
tmp_a:=a0*b1+a1*b0;
tmp_b:=b0*b1;
Sokr(tmp_a,tmp_b);
a:=tmp_a;
b:=tmp_b;
END;

///////     /////////////////////////////
PROCEDURE Minus(const st0,st1:string; var a,b:int64);
var
a0,b0,a1,b1,tmp_a,tmp_b:int64;
BEGIN
DecoderStr(st0,a0,b0);
DecoderStr(st1,a1,b1);
tmp_a:=a0*b1-a1*b0;
tmp_b:=b0*b1;
Sokr(tmp_a,tmp_b);
a:=tmp_a;
b:=tmp_b;
END;

///////       ////////////////////////////////
FUNCTION StrDecoder(const a0,b0:int64):string;
var
a,b:int64;
BEGIN
a:=a0;  b:=b0;
if (a<0)and(b<0) then
 begin
  a:=-a;  b:=-b;
 end;
if a mod b=0 then StrDecoder:=inttostr(a div b) else
 StrDecoder:=inttostr(a)+'/'+inttostr(b);
END;
///////       ////////
FUNCTION GetNewStr(const st0:string;n:byte):string;
var
tmp:string;
BEGIN
if st0='0' then tmp:='' else
 begin
  if st0[1]='-' then
   begin
    tmp:=' '+#151+' ';
    if not((length(st0)-1=1)and(st0[2]='1')) then tmp:=tmp+copy(st0,2,length(st0)-1);
    tmp:=tmp+p[i];
   end else
   begin
    tmp:=' + ';
    if not((length(st0)=1)and(st0[1]='1')) then tmp:=tmp+st0;
    tmp:=tmp+p[i];
   end;
 end;
GetNewStr:=tmp;
END;
///////   /////////////////////////////////
FUNCTION Preobr(const st0:string):string;
var
a0,b0,tmp_a,tmp_b:int64;
tmp:string;
BEGIN
tmp:=st0;

if pos(',',tmp)<>0 then
 begin
  if pos('/',st0)<>0 then delete(tmp,pos('/',st0),99);
  tmp_a:=strtoint64( copy(tmp,1,pos(',',tmp)-1) );
  delete(tmp,1,pos(',',tmp));
  tmp_b:=strtoint64(tmp);

  b0:=trunc(exp(ln(10)*length(tmp)));
  if st0[1]='-' then tmp_a:=-tmp_a;
  a0:=tmp_a*b0+tmp_b;
  Sokr(a0,b0);
  if st0[1]='-' then a0:=-a0;
 end else DecoderStr(tmp,a0,b0);

Preobr:=StrDecoder(a0,b0);
END;


///////  -  ///////////////////////////////////////////
procedure TForm1.Button3Click(Sender: TObject);
begin
button2.Enabled:=true;
updown1.Enabled:=true;
Button1.Enabled:=false;
memo1.Clear;
label7.Visible:=false;
label8.Visible:=false;
label9.Visible:=false;
stringgrid1.Enabled:=true;
count:=0;       //   
d:=1;           //  
n:=0;           //
m:=0;           //
checkbox1.Enabled:=true;
CheckBox1Click(Sender);
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
edit1.Text:=inttostr(UpDown1.Position);
stringgrid1.ColCount:=UpDown1.Position+1;
stringgrid1.RowCount:=UpDown1.Position;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
stringgrid1.Cells[0,0]:='35,8';
stringgrid1.Cells[1,0]:='2,1';
stringgrid1.Cells[2,0]:='-34,5';
stringgrid1.Cells[3,0]:='-11,8';
stringgrid1.Cells[4,0]:='0,5';

stringgrid1.Cells[0,1]:='27,1';
stringgrid1.Cells[1,1]:='-7,5';
stringgrid1.Cells[2,1]:='11,7';
stringgrid1.Cells[3,1]:='-23,5';
stringgrid1.Cells[4,1]:='12,8';

stringgrid1.Cells[0,2]:='11,7';
stringgrid1.Cells[1,2]:='1,8';
stringgrid1.Cells[2,2]:='6,5';
stringgrid1.Cells[3,2]:='7,1';
stringgrid1.Cells[4,2]:='1,7';

stringgrid1.Cells[0,3]:='6,3';
stringgrid1.Cells[1,3]:='10';
stringgrid1.Cells[2,3]:='7,1';
stringgrid1.Cells[3,3]:='3,4';
stringgrid1.Cells[4,3]:='20,8';
//////////////////////////////

UpDown1.Position:=4;
z:=UpDown2.Position;
Button3Click(Sender);
end;

///////      ////////////////
//      n - , m -      
FUNCTION TForm1.GetMax(const n,m:byte; Sender: TObject):byte;
var
a1,b1,a2,b2:int64;
tmp:int64;
BEGIN
tmp:=m;
if checkbox1.Checked then  //===  
 begin
  for i:=m to updown1.Position-2 do
  for j:=i+1 to updown1.Position-1 do
   if ABS(strtofloat(stringgrid2.Cells[n,tmp]))<ABS(strtofloat(stringgrid2.Cells[n,j]))
    then tmp:=j;
 end else
 begin
  for i:=m to updown1.Position-2 do
  for j:=i+1 to updown1.Position-1 do
   begin
    DecoderStr(stringgrid2.Cells[n,tmp],a1,b1);
    DecoderStr(stringgrid2.Cells[n,j],a2,b2);
    if ABS(a1/b1)<ABS(a2/b2) then tmp:=j;
   end;
  end;
GetMax:=tmp;
END;

///////  -  /////////////////////////////////////////
procedure TForm1.Button2Click(Sender: TObject);
begin
{...   }



//   stringgrid
stringgrid2.ColCount:=UpDown1.Position+1;
stringgrid2.RowCount:=UpDown1.Position;
for i:=0 to updown1.Position do
for j:=0 to updown1.Position-1 do
 if checkbox1.Checked then  //===  
  stringgrid2.Cells[i,j]:=stringgrid1.Cells[i,j]
  else stringgrid2.Cells[i,j]:=Preobr(stringgrid1.Cells[i,j]);
//////////////////////////////
updown1.Enabled:=false;
button2.Enabled:=false;

myRect.Left:=1;
myRect.Top:=1;
myRect.Right:=1;
myRect.Bottom:=1;
stringgrid1.Selection:=myRect;
myRect.Left:=-1;
myRect.Top:=-1;
myRect.Right:=-1;
myRect.Bottom:=-1;
stringgrid1.Selection:=myRect;
stringgrid1.Enabled:=false;

checkbox1.Enabled:=false;
label2.Enabled:=false;
edit2.Enabled:=false;
updown2.Enabled:=false;

Button1.Enabled:=true;
Button1Click(Sender);
end;


///////  - ////////////////////////////////////////
procedure TForm1.Button1Click(Sender: TObject);
var
tmp:string;
a,b:int64;
begin
inc(count);
case d of
1: begin  //   
    inc(d);
    max_n:=GetMax(n,n,Sender);

    myRect.Left:=n;
    myRect.Top:=m;
    myRect.Right:=n;
    myRect.Bottom:=10;
    stringgrid2.Selection:=myRect;
    {--- text ---}
    memo1.Lines.Add(#13#10+'= '+inttostr(count)+' =');
    memo1.Lines.Add('  '+inttostr(n+1)+'-    () :');
    memo1.Lines.Add(' ['+inttostr(n+1)+' , '+inttostr(max_n+1)+'] = '+
    stringgrid2.Cells[n,max_n]);
    {--- end ---}
   end;
2: begin     //   
    inc(d);

    myRect.Left:=-1;
    myRect.Top:=-1;
    myRect.Right:=-1;
    myRect.Bottom:=-1;
    stringgrid2.Selection:=myRect;

    if max_n<>n then
     begin
      for i:=0 to updown1.Position do
       begin
        tmp:=stringgrid2.Cells[i,n];
        stringgrid2.Cells[i,n]:=stringgrid2.Cells[i,max_n];
        stringgrid2.Cells[i,max_n]:=tmp;
       end;
      {--- text ---}
      memo1.Lines.Add(#13#10+'= '+inttostr(count)+' =');
      memo1.Lines.Add('   '+inttostr(n+1)+'  '+inttostr(max_n+1)+' .');
      {--- end ---}
     end else
     begin
      {--- text ---}
      memo1.Lines.Add(#13#10+'= '+inttostr(count)+' =');
      memo1.Lines.Add(' ..     '+inttostr(n+1)+
      '- ,    .');
      {--- end ---}
     end;
    if checkbox1.Checked and(stringgrid2.Cells[n,n]<>'1') then d:=25;
   end;

25:begin //       .  ()
    d:=3;
    Button4Click(Sender);
    {--- text ---}
    memo1.Lines.Add(#13#10+'= '+inttostr(count)+' =');
    memo1.Lines.Add(' '+inttostr(n+1)+'-    ');
    {--- end ---}
   end;

3: begin  //  ,     
    inc(d);
    for i:=0 to 9 do k[i]:='';
    for i:=m+1 to updown1.Position-1 do
     if checkbox1.Checked then  //===  
      begin
       fa:=-strtofloat(stringgrid2.Cells[n,i])/strtofloat(stringgrid2.Cells[n,m]);
       SetFormat(fa,fb,z);
       k[i]:=fb;
      end else
      begin
       Delenie(stringgrid2.Cells[n,i],stringgrid2.Cells[n,m],a,b);
       k[i]:=StrDecoder(-a,b);
      end;

    if (k[1]<>'')and(k[1]<>'0') then
     begin
      label7.Caption:=k[1];
      label7.Visible:=true;
     end;
    if (k[2]<>'')and(k[2]<>'0') then
     begin
      label8.Caption:=k[2];
      label8.Visible:=true;
     end;
    if (k[3]<>'')and(k[3]<>'0') then
     begin
      label9.Caption:=k[3];
      label9.Visible:=true;
     end;

    {--- text ---}
    memo1.Lines.Add(#13#10+'= '+inttostr(count)+' =');
    memo1.Lines.Add(' ,     '+
    inttostr(n+1)+'- :');
    for i:=0 to 9 do if (k[i]<>'')and(k[i]<>'0') then
     memo1.Lines.Add('k['+inttostr(i+1)+'] = '+k[i]);
    {--- end ---}
   end;

4: begin
    inc(d);

    myRect.Left:=1;
    myRect.Top:=1;
    myRect.Right:=1;
    myRect.Bottom:=1;
    stringgrid2.Selection:=myRect;
    myRect.Left:=0;
    myRect.Top:=m;
    myRect.Right:=updown1.Position;
    myRect.Bottom:=m;
    stringgrid2.Selection:=myRect;

    {--- text ---}
    memo1.Lines.Add(#13#10+'= '+inttostr(count)+' =');
    memo1.Lines.Add('             .');
    {--- end ---}
    dec(count);
    Button1Click(Sender);  // 
   end;
5: begin   //      
    inc(d);
    label7.Visible:=false;
    label8.Visible:=false;
    label9.Visible:=false;

    myRect.Left:=1;
    myRect.Top:=1;
    myRect.Right:=1;
    myRect.Bottom:=1;
    stringgrid2.Selection:=myRect;
    myRect.Left:=-1;
    myRect.Top:=-1;
    myRect.Right:=-1;
    myRect.Bottom:=-1;
    stringgrid2.Selection:=myRect;

    for j:=n+1 to updown1.Position-1 do
    for i:=0 to updown1.Position do
     if checkbox1.Checked then  //===  
      begin
       fa:=strtofloat(k[j])*strtofloat(stringgrid2.Cells[i,n])+
        strtofloat(stringgrid2.Cells[i,j]);
       SetFormat(fa,fb,z);
       stringgrid2.Cells[i,j]:=fb;
      end else
      begin
       Proizv(k[j],stringgrid2.Cells[i,n],a,b);
       Summa(StrDecoder(a,b),stringgrid2.Cells[i,j],a,b);
       stringgrid2.Cells[i,j]:=StrDecoder(a,b);
      end;
    dec(count);
    Button1Click(Sender);  // 
   end;
6: begin  //   
    inc(n);
    inc(m);
    if n+1=updown1.Position then inc(d)
     else d:=1;
   end;
7: begin //  
    inc(d);
    Button1.Enabled:=false;

    {--- text ---}
    memo1.Lines.Add(#13#10+'= '+inttostr(count)+' =');
    memo1.Lines.Add('       :');
    memo1.Lines.Add('------------------');
    for j:=0 to updown1.Position-1 do
     begin
      tmp:='';
      for i:=0 to updown1.Position-1 do tmp:=tmp+GetNewStr(stringgrid2.Cells[i,j],i);
      tmp:=tmp+' = '+stringgrid2.Cells[i,j];
      if tmp[1]+tmp[2]+tmp[3]=' + ' then delete(tmp,1,3);
      memo1.Lines.Add(tmp);
     end;
    memo1.Lines.Add('------------------');
    {--- end ---}
    //  
    for i:=0 to 9 do k[i]:='0';
    for j:=updown1.Position-1 downto 0 do
     begin
      tmp:=stringgrid2.Cells[updown1.Position,j];
      for i:=j to updown1.Position-1 do
       if checkbox1.Checked then  //===  
       begin
        fa:=strtofloat(tmp)-strtofloat(stringgrid2.Cells[i,j])*strtofloat(k[i]);
        SetFormat(fa,fb,z);
        tmp:=fb;
 //       fa:=strtofloat(stringgrid2.Cells[i,j])*strtofloat(k[i]);
       end else
       begin
        Proizv(stringgrid2.Cells[i,j],k[i],a,b);
        Minus(tmp,Strdecoder(a,b),a,b);
        tmp:=Strdecoder(a,b);
       end;

     if checkbox1.Checked then  //===  
      begin
       fa:=fa/strtofloat(stringgrid2.Cells[j,j]);
       SetFormat(fa,fb,z);
       k[j]:=fb;
      end else
      begin
       Delenie(Strdecoder(a,b),
       stringgrid2.Cells[j,j],a,b);
       k[j]:=Strdecoder(a,b);
      end;
     end;

    {--- text ---}
    memo1.Lines.Add('  :');
    for i:=updown1.Position-1 downto 0 do
     memo1.Lines.Add(p[i]+' = '+k[i]);
    memo1.Lines.Add('');

    {--- mytext ---}
    memo1.Lines.Add('          !');
    memo1.Lines.Add('#########################');
    memo1.Lines.Add('#                 #');
    memo1.Lines.Add('#                     #');
    memo1.Lines.Add('#                                                      #');
    memo1.Lines.Add('#  www.pascalstudy.narod.ru #');
    memo1.Lines.Add('# e-mail: gfifdos@yandex.ru  #');
    memo1.Lines.Add('#########################');
    {--- end ---}
   end;
end; // end case


end;

procedure TForm1.StringGrid1KeyPress(Sender: TObject; var Key: Char);
begin
if key='.' then key:=',';
end;

procedure TForm1.Button4Click(Sender: TObject);
var
a,b:int64;
tmp:string;
begin
tmp:=stringgrid2.Cells[n,n];
for i:=0 to updown1.Position do
 if checkbox1.Checked then  //===  
  begin
   fa:=strtofloat(stringgrid2.Cells[i,n])/strtofloat(tmp);
   SetFormat(fa,fb,z);
   stringgrid2.Cells[i,n]:=fb;
  end else
  begin
   Delenie(stringgrid2.Cells[i,n],tmp,a,b);
   stringgrid2.Cells[i,n]:=StrDecoder(a,b);
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
if checkbox1.Checked then
 begin
  label2.Enabled:=true;
  edit2.Enabled:=true;
  updown2.Enabled:=true;
 end else
 begin
  label2.Enabled:=false;
  edit2.Enabled:=false;
  updown2.Enabled:=false;
 end;
end;

procedure TForm1.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
edit2.Text:=inttostr(UpDown2.Position);
z:=UpDown2.Position;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
BigResult.ShowModal;
end;

end.
